/*
bricks512	by PPs
started:	17.07.2022
finished:	22.07.2022
*/

	icl 'atari.hea'

BEGIN	equ $2000

pmg	equ $5000
m0	equ pmg+$180
p0	equ m0+128
p1	equ p0+128
p2	equ p1+128
p3	equ p2+128
riball	equ $80
hpos	equ $81
yball	equ $83
xball	equ $84
yyball	equ $85

	org BEGIN
;------------
	.proc main
	mva >pmg pmbase		;missiles and players data address
	sub #2			;pmg = $50 ;), so we get $4e here
	sta hposp1
	sta 707
	adc #$21
	sta 705
	sta hposp2
	adc #$22
	sta hposp3
	sta 706
	mva #$03 pmcntl		;enable players and missiles
	sta sizep0
	sta sizep1
	sta sizep2
	sta sizep3
	sta skctl
	tax
	mva #0 audctl
	mva #@dmactl(narrow|dma|players|missiles|lineX2) 559	;$2d
	lda #$90
	sta hpos
	lda #14
	sta 704
	sta hitclr
	ldy #2
	mva #16 (88),y		;0 Points
	dey	
	sta (88),y		;00 Points
;ball y richtung
	sty yyball	;1 := hoch
;--- paddle
	ldy #108
	lda #$ff
lx	sta p0,y
	iny
	dex
	bpl lx
;--- bricks
	ldx #5
lx1	txa
	pha
;--- bricks
	ldx #3
chg	ldy #18
	lda #$ff
@	sta p1,y
	sta p2,y
	sta p3,y
	iny
	dex
	bpl @-
	lda chg+1
	adc #6
	sta chg+1
;---
	pla
	tax
	dex
	bpl lx1
;ball x richtung
	lda random
	and #1
	sta riball	;0 := links, 1 := rechts
	.endp
;------------
	.proc startloop
	jsr loopsame
;ball+paddle
	lda hpos
	add #15
	sta xball
	mva #108 yball
	jsr paintball
;---
	lda ptrig0
	beq mainloop
	jmp startloop
	.endp
;------------
	.proc mainloop
	sta hitclr
	jsr loopsame
	jsr yy_ball
;--- checkhit
	lda xball
	cmp #$b0	;Wand rechts
	bcs nix
	cmp #$40	;Wand links
	bcc nix
;collusion ?
	lda kolm0p
	beq nix
	cmp #%00000001
	beq hitplayer
;hit brick
	jsr score
	mva #0 yyball	;ball down
	jsr clearbrick
nix	jmp mainloop	;rts
hitplayer
	sta yyball	;ball up
	lda hpos
	add #5
	cmp xball
	bcs now_left
	adc #15
	cmp xball
	bcc now_right
	jmp mainloop
now_left
	mva #0 riball
	jmp mainloop
now_right
	inc riball
	jmp mainloop
	.endp
;------------
	.proc loopsame
	lda 20
@	cmp 20
	beq @-
	lda #0
	sta audc1
	sta audf1
	lda paddle0
	cmp #$b4
	bcs nochange
	cmp #$6a
	bcc nochange
	eor #$ff
	sta hpos
nochange
	mva hpos hposp0
	mva xball hposm0
	rts
	.endp
;------------
	.proc clearbrick
	mva #%10100011 audc1
	mva #53 audf1
	lda kolm0p
	cmp #%00000010
	beq player1
	cmp #%00000100
	beq player2
;player3
	mwa #p3 clear.lx+1
	jmp clear
player2
	mwa #p2 clear.lx+1
	jmp clear
player1
	mwa #p1 clear.lx+1
	.endp
;------------
	.proc clear
	lda yball	;soll immer gerade sein zum Lschen
	ror		;:2
	clc		;ungeraden Rest vergessen
	rol		;*2
	tay
	;---
	lda #0
	ldx #5
lx	sta p1,y
	dey
	dex
	bpl lx
	rts
	.endp
;------------
	.proc yy_ball
;ball xpos
	lda riball
	beq left
;right
	inc xball
	lda xball
	cmp #$b0
	bcc ball_y
	mva #0 riball	;now left
	jmp ball_y
left
	dec xball
	lda xball
	cmp #$51
	bcs ball_y
	inc riball	;now right
ball_y
;ball ypos
	lda yyball
	beq runter	;0 := runter, 1 := hoch
hoch
	dec yball
	lda yball
	cmp #18
	beq chgru
	jmp paintb
chgru
	mva #0 yyball
paintb
	jsr paintball
	rts
runter
	inc yball
	lda yball
	bmi lost
	jmp paintb
lost	lda #$34
	mva #%10000011 audc1
	mva #53 audf1
	jmp score.lost
	.endp
;------------
	.proc paintball
	ldy yball
	lda #0
	sta m0-3,y
	sta m0,y
	lda #$3
	sta m0-1,y
	sta m0-2,y
	rts
	.endp
;------------
	.proc score
	ldy #2
	lda (88),y
	add #1
	sta (88),y
	cmp #16+10	;10?
	beq ten
	cmp #16+8	;18???
	bne @+
	dey
	lda (88),y
	cmp #16+1
	beq win
@	rts
ten	mva #16 (88),y
	dey
	lda (88),y
	add #1
	sta (88),y
	rts
win	lda #$c4
lost	sta 710
	sta 20
	lda 19
@	cmp 19
	beq @-
	jmp $e477
	.endp
;------------
	run main